import csv
import datetime
import re
import math

#STOLEN AND FORGOTTEN BOOKS


with open('empty6.csv', 'rb') as f:
    reader = csv.reader(f)
    inputArray = list(reader)

# bibNumber, itemNumber, checkOutDate, checkInDate, returned, checkInLength, title, callNumber, genre, itemType, author, year

outputArray = [['bibNumber', 'itemNumber', 'checkOutDate', 'checkInDate', 'returned', 'checkOutLength', 'title', 'callNumber', 'genre', 'itemType', 'author', 'year', 'checkoutDay','checkinDay']]

dtf = '%Y-%m-%d %H:%M:%S'
crapArray = ['FIC', 'CAS', 'CD', 'YA', 'Fiction', 'MYSTERY', 'WESTERN', 'SCI-FIC']

first = datetime.datetime(2005, 1, 1)

for item in inputArray[1:]:
  
  checkOut = datetime.datetime.strptime(item[1], dtf)
  checkIn = '' if item[2]== 'NULL' else datetime.datetime.strptime(item[2], dtf)
  cnSplitTemp = item[4].split()
  cnSplit = []
  for s in cnSplitTemp:
    t = re.split('(\d+)', s)
    cnSplit.extend(filter(None, t))
  print cnSplit
  l = []
  l.append(item[10]) #bibNumber
  l.append(item[11]) #itemNumber
  l.append(item[1])  #checkOutDate
  l.append('' if item[2]== 'NULL' else item[2])  #checkInDate
  l.append(0 if item[2]=='NULL' else 1)  #returned
  l.append('' if item[2]=='NULL' else (checkIn-checkOut).total_seconds()); #checkOutLength
  l.append(item[3]) #title
  l.append(item[4]) #callNumber
  l.append('sci' if item[5]=='1' else ('mys' if item[6]=='1' else ('wes' if item[7]=='1' else ('fic' if item[8]=='1' else ('yab' if 'YA B ' in item[4] else ('yab' if 'YA B.' in item[4] else 'ya')))))) #genre
  l.append('cas' if 'CAS' in cnSplit[0] else 'cd' if 'CD' in cnSplit[0] else 'book') #itemType
  
  author = ''
  if l[8] != 'yab':
    for s in cnSplit:
      if s not in crapArray and s.isdigit() == False:
        author = s
        break
  l.append(author) #author
  l.append(cnSplit[-1] if cnSplit[-1].isdigit() else '') #year
  
  l.append(math.floor((checkOut-first).total_seconds()/86400))
  l.append('' if item[2]== 'NULL' else math.floor((checkIn-first).total_seconds()/86400))
  
  if l[8] != 'yab' and l[10] != '0' and (checkOut.year < 2017 or checkOut.month > 6):
    outputArray.append(l)
    print l
  

with open("output.csv", "wb") as f:
    writer = csv.writer(f)
    writer.writerows(outputArray)

