class entry {
  boolean returned;
  int author2;
  int checkoutDay;
  int checkinDay;
  String itemType;
  String mediumType;
  String author;
  String title;
  vec3f loc;
  
  entry(boolean r, int a2, int cod, int cid, String i, String m, String a, String t, vec3f l) {
    returned = r;
    author2 = a2;
    checkoutDay = cod;
    checkinDay = cid;
    itemType = i;
    mediumType = m;
    author = a;
    title = t;
    loc = l;
  }
  
  boolean filtered(String t, String letter) {
    if (!letter.equals(" ") && author.length() < 1) { return true; }
    if (!letter.equals(" ") && !letter.equals(author.substring(0,1).toLowerCase())) { return true; }
    switch (t){
      case "item":
      case "medium":
        return false;
      case "genre":
        if (itemType.equals("mys") || itemType.equals("wes") || itemType.equals("sci")) {return false;}
        else {return true;}
      case "cd/cas":
        if (mediumType.equals("cd") || mediumType.equals("cas")) {return false;}
        else {return true;}
      case "book":
        if (mediumType.equals("book")) {return false;}
        else {return true;}
      case "sci":
      case "mys":
      case "wes":
      case "fic":
      case "ya":
        if (itemType.equals(t)) {return false;}
        else {return true;}
    }
    
    return true;
  }
  
  color getColor(String t) {
    String state = "";
    switch (t){
      case "item":
        state = (itemType.equals("ya") || itemType.equals("fic")) ? itemType : "gen";
        break;
      case "genre":
        state = itemType;
        break;
      case "medium":
      case "cd/cas":
        state = mediumType;
        break;
    }
    
    color c = color(0, 0, 0);
    
    switch(state) {
      case "gen":
      case "sci":
      case "cas":
        c = color(0,35,255);
        break;
      case "fic":
      case "mys":
      case "book":
        c = color(255,220,0);
        break;
      case "ya":
      case "wes":
      case "cd":
        c = color(255,0,35);
        break;
    }
    return c;
  }
  
}