void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void guiSetup() {
  cp5 = new ControlP5(this);
  cp5.setAutoDraw(false);
  r = cp5.addRadioButton("radioButton")
         .setPosition(20,20)
         .setSize(25,25)
         .setColorBackground(color(50))
         .setColorForeground(color(210))
         .setColorActive(color(255))
         .setColorLabel(color(255))
         .setItemsPerRow(5)
         .setSpacingColumn(80)
         .addItem("item",1)
         .addItem("medium",2)
         .addItem("genre",3)
         .addItem("cd/cas",4)
         .addItem("book",5)
         .addItem("sci-fi",6)
         .addItem("mystery",7)
         .addItem("western",8)
         .addItem("fiction",9)
         .addItem("young adult",10)
         ;
     
   int a = 50;
   color clist[] = {color(0,0,0,a),color(0,0,0,a),color(0,35,255,a),
     color(0,0,0,a),color(255,220,0,a),color(0,35,255,a),
     color(255,220,0,a),color(255,0,35,a),color(255,220,0,a),
     color(255,0,35,a)};
   int count = 0;
   for(Toggle t:r.getItems()) {
     t.getCaptionLabel().setColorBackground(clist[count]);
     t.getCaptionLabel().getStyle().moveMargin(-7,0,0,-3);
     t.getCaptionLabel().getStyle().movePadding(7,0,0,3);
     t.getCaptionLabel().getStyle().backgroundWidth = 80;
     t.getCaptionLabel().getStyle().backgroundHeight = 20;
     t.getCaptionLabel().setFont(createFont("Lato-Light",10));
     count++;
   }
   
  r.activate(0);
     
  b = cp5.addRadioButton("viewButton")
         .setPosition(20,80)
         .setSize(25,25)
         .setColorBackground(color(50))
         .setColorForeground(color(210))
         .setColorActive(color(255))
         .setColorLabel(color(255))
         .setItemsPerRow(3)
         .setSpacingColumn(80)
         .addItem("words",1)
         .addItem("geometry",2)
         .addItem("titles",3)
         ;
         
  for(Toggle t:b.getItems()) {
     t.getCaptionLabel().setColorBackground(color(0,0,0,a));
     t.getCaptionLabel().getStyle().moveMargin(-7,0,0,-3);
     t.getCaptionLabel().getStyle().movePadding(7,0,0,3);
     t.getCaptionLabel().getStyle().backgroundWidth = 80;
     t.getCaptionLabel().getStyle().backgroundHeight = 20;
     t.getCaptionLabel().setFont(createFont("Lato-Light",10));
     count++;
   }

   b.activate(2);
   
   myTextlabelA = cp5.addTextlabel("label")
                    .setText("")
                    .setPosition(20,120)
                    .setColorValue(255)
                    .setFont(createFont("Lato-Light",10))
                    ;
}

void viewButton(int a) {
  boolean prevSentence = sentence;
  if (a == 1) {
    geometry = false;
    sentence = false;
  } else if (a == 2) {
    geometry = true;
    sentence = false;
  } else if (a == 3) {
    geometry = true;
    sentence = true;
  }
  if (sentence != prevSentence) { 
    myTextlabelA.setText("");
    near = false; 
    nearIndex = 0;
  }
}

void radioButton(int a) {
  if (a != -1) { typeP = a -1; }
  println("a radio Button event: "+a);
}